/*

 Ŀ
   CLIPPER FUNCTION   :- FIVECAL()                                          
 Ĵ
   Written by         :- G.M. BAERKEN < G.B. SOFTWARE (c) >                 
   Date written       :- Monday November 17th, 1996                         
 Ĵ
   Syntax             :- FIVECAL(OWND,cDateFld)                             
 Ĵ
   Purpose            :- To display a Calendar on screen allowing the user  
                      :- to select a given date                             
   Where              :- OWND = The name of the Window Handle it runs under 
 

 1/23/06 - changed FT_Lday() to fix error in handling leap years;
         - added ability to highlight the current date for user's reference;
         - resource was modified to make it about 2/3 the screen size of the
           original calendar dialog -- which aesthetically seemed too big;
         - changed variable's names to Hungarian notation to aid readability;
         - eliminated private memvars for button objects by use of static
           array aoDay[37] which contains all the button objects, thereby
           eliminating need for use of macro operator to decode substitution;
         - Works fine in xHarbour 32 bits, but must use BWCC32.dll. If don't
           want to use that, then eliminate shaded box control from the
           dialog, which is the only Borland control used.

         NOTE: the "Schedule" dialog resource, because it has 42 buttons, may
         cause an error when you try to add it to your .RC file. I had that
         problem and had to delete a few unused dialogs from my .RC file in
         order to get Resource Workshop to accept the addition of this one.

                                        - R.W. Seiler
*/

#include "FiveWin.Ch"

/* Was able to drop all these orig. vers. priv. memvars by use of aoDay[37]...
Memvar cThisDay

Memvar Day1,Day2,Day3,Day4,Day5,Day6,Day7,Day8,Day9,Day10,Day11,Day12,Day13,;
      Day14,Day15,Day16,Day17,Day18,Day19,Day20,Day21,Day22,Day23,Day24,Day25,;
      Day26,Day27,Day28,Day29,Day30,Day31,Day32,Day33,Day34,Day35,Day36,Day37
*/
STATIC oDlg,oSay,cResfile,aoDay := {}
STATIC dNewday1,dNewday2,nToday,nThisMonth,dMonthStart,nFirstDOW,dMonthEnd,nMonthLen,;
      dDayNew,cHeader,dMonthNew,aLastyr,cLastyear1,nNowMonth := 0

FUNCTION FiveCal(oWnd,cDateFld) // Optional 2nd param gives name of date field
                                // to mention on dialog's title bar.

LOCAL n, OldDFmt, oSay21,oSay22,oSay23,oSay24,oSay25,oSay26,oSay27

*LOCAL hOldRes := GetResources()  // If need to load res. as a separate dll

DEFAULT cDateFld := ""

aoDay := ARRAY(37)

// Get the current DATE format
OldDFmt := SET(4)

// Set it to BRITISH so as out manipulation works
SET DATE BRITISH

cResFile := "Fivecald.dll"

CursorWait()

/*
   // If needed, to set resources to special DLL with calendar dialog...
IF SetResources(cResFile) < 32
   MsgStop(cResFile + " not found. Will abort calendar." )

   RETURN NIL
ENDIF
*/

dNewday1    := DATE()
dNewday2    := CTOD('  /  /  ')
nToday      := DAY(date())
nNowMonth   := nThisMonth := MONTH(DATE())
dMonthStart := FT_fDay(DATE())
nFirstDOW   := DOW(dMonthStart)
dMonthEnd   := FT_lDay(DATE())

nMonthLen   := DAY(dMonthEnd)
dDayNew     := DATE()
cHeader     := OemToAnsi('                        ')
oSay        := cHeader

// Display our screen
// If you get a "Cannot create dialog error," make sure that in the resource
// that the classname is blank - NOT "BorGrayDlg" or some such class.

IF EMPTY(cDateFld)
   DEFINE DIALOG oDlg RESOURCE "SCHEDULE" OF oWnd
ELSE
   DEFINE DIALOG oDlg RESOURCE "SCHEDULE" OF oWnd;
          TITLE "Click On Day To Set "+cDateFld+" Date..."
ENDIF

REDEFINE SAY oSay21 ID 21 OF oDlg COLOR CLR_HBLUE
REDEFINE SAY oSay22 ID 22 OF oDlg COLOR CLR_HBLUE
REDEFINE SAY oSay23 ID 23 OF oDlg COLOR CLR_HBLUE
REDEFINE SAY oSay24 ID 24 OF oDlg COLOR CLR_HBLUE
REDEFINE SAY oSay25 ID 25 OF oDlg COLOR CLR_HBLUE
REDEFINE SAY oSay26 ID 26 OF oDlg COLOR CLR_HBLUE
REDEFINE SAY oSay27 ID 27 OF oDlg COLOR CLR_HBLUE

REDEFINE BUTTON aoDay[1]  PROMPT " "  ID 100  OF oDlg ACTION dNewDay1:=DayClick(aoDay[1] )
REDEFINE BUTTON aoDay[2]  PROMPT " "  ID 101  OF oDlg ACTION dNewDay1:=DayClick(aoDay[2] )
REDEFINE BUTTON aoDay[3]  PROMPT " "  ID 102  OF oDlg ACTION dNewDay1:=DayClick(aoDay[3] )
REDEFINE BUTTON aoDay[4]  PROMPT " "  ID 103  OF oDlg ACTION dNewDay1:=DayClick(aoDay[4] )
REDEFINE BUTTON aoDay[5]  PROMPT " "  ID 104  OF oDlg ACTION dNewDay1:=DayClick(aoDay[5] )
REDEFINE BUTTON aoDay[6]  PROMPT " "  ID 105  OF oDlg ACTION dNewDay1:=DayClick(aoDay[6] )
REDEFINE BUTTON aoDay[7]  PROMPT " "  ID 106  OF oDlg ACTION dNewDay1:=DayClick(aoDay[7] )
REDEFINE BUTTON aoDay[8]  PROMPT " "  ID 107  OF oDlg ACTION dNewDay1:=DayClick(aoDay[8] )
REDEFINE BUTTON aoDay[9]  PROMPT " "  ID 108  OF oDlg ACTION dNewDay1:=DayClick(aoDay[9] )
REDEFINE BUTTON aoDay[10]  PROMPT " " ID 109  OF oDlg ACTION dNewDay1:=DayClick(aoDay[10])
REDEFINE BUTTON aoDay[11]  PROMPT " " ID 110  OF oDlg ACTION dNewDay1:=DayClick(aoDay[11])
REDEFINE BUTTON aoDay[12]  PROMPT " " ID 111  OF oDlg ACTION dNewDay1:=DayClick(aoDay[12])
REDEFINE BUTTON aoDay[13]  PROMPT " " ID 112  OF oDlg ACTION dNewDay1:=DayClick(aoDay[13])
REDEFINE BUTTON aoDay[14]  PROMPT " " ID 113  OF oDlg ACTION dNewDay1:=DayClick(aoDay[14])
REDEFINE BUTTON aoDay[15]  PROMPT " " ID 114  OF oDlg ACTION dNewDay1:=DayClick(aoDay[15])
REDEFINE BUTTON aoDay[16]  PROMPT " " ID 115  OF oDlg ACTION dNewDay1:=DayClick(aoDay[16])
REDEFINE BUTTON aoDay[17]  PROMPT " " ID 116  OF oDlg ACTION dNewDay1:=DayClick(aoDay[17])
REDEFINE BUTTON aoDay[18]  PROMPT " " ID 117  OF oDlg ACTION dNewDay1:=DayClick(aoDay[18])
REDEFINE BUTTON aoDay[19]  PROMPT " " ID 118  OF oDlg ACTION dNewDay1:=DayClick(aoDay[19])
REDEFINE BUTTON aoDay[20]  PROMPT " " ID 119  OF oDlg ACTION dNewDay1:=DayClick(aoDay[20])
REDEFINE BUTTON aoDay[21]  PROMPT " " ID 120  OF oDlg ACTION dNewDay1:=DayClick(aoDay[21])
REDEFINE BUTTON aoDay[22]  PROMPT " " ID 121  OF oDlg ACTION dNewDay1:=DayClick(aoDay[22])
REDEFINE BUTTON aoDay[23]  PROMPT " " ID 122  OF oDlg ACTION dNewDay1:=DayClick(aoDay[23])
REDEFINE BUTTON aoDay[24]  PROMPT " " ID 123  OF oDlg ACTION dNewDay1:=DayClick(aoDay[24])
REDEFINE BUTTON aoDay[25]  PROMPT " " ID 124  OF oDlg ACTION dNewDay1:=DayClick(aoDay[25])
REDEFINE BUTTON aoDay[26]  PROMPT " " ID 125  OF oDlg ACTION dNewDay1:=DayClick(aoDay[26])
REDEFINE BUTTON aoDay[27]  PROMPT " " ID 126  OF oDlg ACTION dNewDay1:=DayClick(aoDay[27])
REDEFINE BUTTON aoDay[28]  PROMPT " " ID 127  OF oDlg ACTION dNewDay1:=DayClick(aoDay[28])
REDEFINE BUTTON aoDay[29]  PROMPT " " ID 128  OF oDlg ACTION dNewDay1:=DayClick(aoDay[29])
REDEFINE BUTTON aoDay[30]  PROMPT " " ID 129  OF oDlg ACTION dNewDay1:=DayClick(aoDay[30])
REDEFINE BUTTON aoDay[31]  PROMPT " " ID 130  OF oDlg ACTION dNewDay1:=DayClick(aoDay[31])
REDEFINE BUTTON aoDay[32]  PROMPT " " ID 131  OF oDlg ACTION dNewDay1:=DayClick(aoDay[32])
REDEFINE BUTTON aoDay[33]  PROMPT " " ID 132  OF oDlg ACTION dNewDay1:=DayClick(aoDay[33])
REDEFINE BUTTON aoDay[34]  PROMPT " " ID 133  OF oDlg ACTION dNewDay1:=DayClick(aoDay[34])
REDEFINE BUTTON aoDay[35]  PROMPT " " ID 134  OF oDlg ACTION dNewDay1:=DayClick(aoDay[35])
REDEFINE BUTTON aoDay[36]  PROMPT " " ID 135  OF oDlg ACTION dNewDay1:=DayClick(aoDay[36])
REDEFINE BUTTON aoDay[37]  PROMPT " " ID 136  OF oDlg ACTION dNewDay1:=DayClick(aoDay[37])

REDEFINE GET oSay VAR cHeader ID 200 OF oDlg //READONLY

REDEFINE BUTTON ID 150 OF oDlg ACTION SetNewDate("PrevMonth")
REDEFINE BUTTON ID 151 OF oDlg ACTION SetNewDate("NextMonth")
REDEFINE BUTTON ID 152 OF oDlg ACTION SetNewDate("PrevYear")
REDEFINE BUTTON ID 153 OF oDlg ACTION SetNewDate("NextYear")

REDEFINE BUTTON ID 199 OF oDlg ACTION (dNewDay1 := CTOD('  /  /  '),oDlg:End)

// Hide buttons initially
FOR n = 1 to 37

* cThisDay := 'Day'+LTRIM(STR(n))  // Name of the "day" object to contain obj
* &cThisDay:Hide()   // Hide Day Buttons (objects, each named by cThisDay)

  aoDay[n]:Hide()  // Hide Day Buttons (objects, each contained in aoDay)

  SysRefresh()

NEXT n

ACTIVATE DIALOG oDlg CENTERED ON INIT(SetCal())

// Reset Date to format on coming here
SET(4,OldDFmt)

SysRefresh()

// Set resources back to app's main resources file...
*SetResources(hOldRes)

RETURN(dNewday1)
*sc-------------------------
// Now turn on required buttons and place the day number on them
FUNCTION SetCal()
LOCAL x, dToday := DATE(),lToday := .f.,nToday := 0,nBegYr := 0,nBegMo := 0,;
      nNewMo := 0,nNewYr := 0, nDay := 0,oFont

// nToday, lToday, etc. facilitate highlighting today's date below.
// With ordinary non-bitmap buttons, can't highlight with color or
// so have to use parenthesis and bolding of font for this purpose.
nToday := DAY(dToday)
nBegYr := YEAR(dToday)
nNewMo := MONTH(dMonthEnd)
nNewYr := YEAR(dMonthEnd)

DEFINE FONT oFont NAME "TAHOMA BOLD" SIZE 0,-12 UNDERLINE ITALIC

FOR x = 1 to 37
  nDay := x + 1 - nFirstDOW
  IF nDay = nToday
     lToday := .t.
  ELSE
     lToday := .f.
  ENDIF
*  Was able to replace private memvar cThisDay and its use of macro operator 
*  with more memory efficient static aoDay[37].
*  cThisDay := 'Day'+LTRIM(STR(x)) // In orig vers, each butn named "Day1...37"
  if x < nFirstDOW
*    &cThisDay:Hide()
     aoDay[x]:Hide()
  else
    if x > nMonthLen - 1 + nFirstDOW
*      &cThisDay:Hide()
       aoDay[x]:Hide()
    else
*     &cThisDay:Show()
      aoDay[x]:Show()
      IF lToday .AND. nNewMo = nNowMonth .AND. nNewYr = nBegYr
         // Highlight today's date by surrounding it with parentheses...
**        &cThisDay:Settext( "(" + STR(x+1-nFirstDOW,2) + ")" )
*         aoDay[x]:Settext( "[" + STR(x+1-nFirstDOW,2) + "]" )
         aoDay[x]:Settext( STR(x+1-nFirstDOW,2) )
         aoDay[x]:SetFont(oFont)
*         SetTextColor(aoDay[x]:hDC, CLR_HGREEN)  // Doesn't work. Why not???
      ELSE
*        &cThisDay:Settext(STR(x+1-nFirstDOW,2))
         aoDay[x]:Settext(STR(x+1-nFirstDOW,2))
      ENDIF
*     &cThisDay:Refresh()
      aoDay[x]:Refresh()
    endif
  endif

  SysRefresh()
NEXT

// Set the Month and Year for the Header on the Dialogue
cHeader := ALLTRIM(OemToAnsi(CMONTH(dMonthEnd)+' '+LTRIM(STR(YEAR(dMonthEnd)))))
oSay:Settext(cHeader)
oSay:Refresh()

oFont:End()

SysRefresh()

RETURN NIL
*------------------

// Move forward or back a month or a year depending on what was clicked
FUNCTION SetNewDate(cDirection)

dMonthEnd  := FT_lDay(dDayNew)
nMonthLen  := Day(dMonthEnd)
aLastyr    := FT_Dayofyr(dDayNew)
cLastyear1 := aLastyr[2]

DO CASE
  CASE cDirection == 'PrevYear'
    dMonthNew    := dDayNew-365
  CASE cDirection == 'PrevMonth'
    dMonthNew    := dMonthStart-1  &&30
* CASE cDirection == 'PrevDay'     // Not used
*   dMonthNew    := dDayNew+1
  CASE cDirection == 'NextMonth'
    dMonthNew    := dMonthEnd+1
  CASE cDirection == 'NextYear'
    dMonthNew    := dMonthEnd-1+365
ENDCASE

SysRefresh()

dDayNew     := dMonthNew
*nThisMonth := dMonthNew
dMonthStart := FT_fDay(dMonthNew)  // param was nThisMonth
nFirstDOW   := DOW(dMonthStart)
dMonthEnd   := FT_lDay(dMonthNew)
nMonthLen   := Day(dMonthEnd)

*SetCal(cThisDay)
SetCal()

RETURN NIL
*---------------------
// Set the return Date as per button clicked
FUNCTION DayClick(oThisDay)
Local cNewDay, dNewDay1

cNewDay  := LTRIM(oThisDay:cCaption)+"/"+STR(MONTH(dMonthEnd))+"/"+STR(YEAR(dMonthEnd))
dNewDay1 := CTOD(cNewDay)

oDlg:End()

SysRefresh()

RETURN(dNewDay1)
*----------------------------------------------------
* Functions standing in for Nanforum functions:
FUNCTION FT_FDAY(dDate)
LOCAL dMonthStart := CTOD("")

dMonthStart := dDate - (DAY(dDate)-1)

RETURN dMonthStart
*-----------------
FUNCTION FT_LDAY(dDate)
LOCAL dMonthEnd := CTOD(""),nMo := 0,nYr := 0,cYr := ""

// Remember, we're using British dd/mm/yy date format here...

nMo := MONTH(dDate)
nYr := YEAR(dDate)
cYr := STR(nYr,4)
cYr := SUBSTR(cYr,3,2)

DO CASE
   CASE nMo = 1
        dMonthEnd := CTOD("31/01/"+cYr)
   CASE nMo = 2
       // Original code wrong - used 2 digit numeric to compare to 4-digit data 
*      IF nYr = 00 .OR. nYr = 04 .OR. nYr = 08
       // Leap years (always in US presidential election years so candidates
       // can have an extra day in which to campaign)...
       IF cYr = "00" .OR. cYr = "04" .OR. cYr = "08" .OR. cYr = "12" .OR. ;
          cYr = "16" .OR. cYr = "20" .OR. cYr = "24" .OR. cYr = "28" .OR. ;
          cYr = "32" .OR. cYr = "36" .OR. cYr = "40" .OR. cYr = "44" .OR. ;
          cYr = "48" .OR. cYr = "52" .OR. cYr = "56" .OR. cYr = "60" .OR. ;
          cYr = "64" .OR. cYr = "68" .OR. cYr = "72" .OR. cYr = "76" .OR. ;
          cYr = "80" .OR. cYr = "84" .OR. cYr = "88" .OR. cYr = "92" .OR. ;
          cYr = "96" 
        dMonthEnd := CTOD("29/02/"+cYr)
       ELSE
        dMonthEnd := CTOD("28/02/"+cYr)
       ENDIF
   CASE nMo = 3
        dMonthEnd := CTOD("31/03/"+cYr)
   CASE nMo = 4
        dMonthEnd := CTOD("30/04/"+cYr)
   CASE nMo = 5
        dMonthEnd := CTOD("31/05/"+cYr)
   CASE nMo = 6
        dMonthEnd := CTOD("30/06/"+cYr)
   CASE nMo = 7
        dMonthEnd := CTOD("31/07/"+cYr)
   CASE nMo = 8
        dMonthEnd := CTOD("31/08/"+cYr)
   CASE nMo = 9
        dMonthEnd := CTOD("30/09/"+cYr)
   CASE nMo = 10
        dMonthEnd := CTOD("31/10/"+cYr)
   CASE nMo = 11
        dMonthEnd := CTOD("30/11/"+cYr)
   CASE nMo = 12
        dMonthEnd := CTOD("31/12/"+cYr)
ENDCASE

RETURN dMonthEnd
*-----------------
FUNCTION FT_Dayofyr(dDate)
LOCAL aLastyr := ARRAY(4),nYr := 0,cYr := ""

  nYr := YEAR(dDate)
  cYr := STR(nYr,4)
  aLastyr := { SUBSTR(cYr,1,1),SUBSTR(cYr,2,1),SUBSTR(cYr,3,1),SUBSTR(cYr,4,1)}

RETURN aLastyr
*-----------------
